#!/bin/sh

usage() {
	echo "Usage: $(basename $0) [FILE]"
	echo
	echo "Forward RX OMCI messages from the log generated by ONU daemon "
	echo "into running instance of OMCI ONU daemon."

	exit
}

do_simulate() {
	local file=$1

	while read line; do
		if echo $line | grep -q 'rx|'; then
			local msg=$(echo $line | cut -d'|' -f 8)

			if ! echo $msg | grep -q '[0-9]'; then
				continue
			fi

			omci_pipe.sh rmr $(echo $msg | cut -d' ' -f1-40)
		fi

		if echo $line | grep -q 'ploam ds:'; then
			echo $line
		fi
		if echo $line | grep -q 'ploam ds|'; then
			local msg=$(echo $line | cut -d'|' -f 2 | cut -d' ' -f1-12 | sed 's/ / 0x/g')
			onu ploamdi 0x$msg
			onu ploamsg
		fi
		cmd=
	done < $file
}

if [ "x$1" = "x-h" ]; then
	usage
fi

if [ ! "x$1" = "x" ]; then
	file=$1
else
	file=/onu_control.log
fi

if [ ! -e $file ]; then
	echo "Can't open log file '$file'!"
	exit 1
fi

do_simulate $file
